﻿/*
 * Created by SharpDevelop.
 * User: utente
 * Date: 2/4/2019
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Net;
using System.Net.Mail;
using System.Collections.Generic;
using System.IO;
using System.Diagnostics;
using System.Reflection;

namespace MainProject
{
	class Program
	{
		static string oggetto = "";
		static string mittente ="";
		static string emailMittente = "";
		static List<string> A = new List<string>();
		static List<string> Cc = new List<string>();
		static List<string> Ccn = new List<string>();
		
		static List<string> Allegati = new List<string>();

		static string testo = "";

		static string csvFile = "";
		static char csvSep = ',';
		static int csvLine = 0;
		
		static string user = "";
		static string pass = "";
		
		static string server = "";
		static int port = 25;
		static int timeout = 10000;
		
		static bool showHelp = false;

		public static void Main(string[] args)
		{
			// importo i dati
			if (args.Length == 0) showHelp = true;
			
			for (int i = 0; i < args.Length; ++i) {
				if (!ImportaDato(args[i])) return;
			}

			// help in linea
			if (showHelp) {

				Assembly ass = Assembly.GetExecutingAssembly();
				string version = "";
				
				if (ass != null) {
				    FileVersionInfo FVI = FileVersionInfo.GetVersionInfo(ass.Location);
				    version = String.Format("{0} v{1:0}.{2:0}.{3:0}",
				                  FVI.ProductName,
				                  FVI.FileMajorPart,
				                  FVI.FileMinorPart,
				                  FVI.FileBuildPart);
				}

				Console.WriteLine(version + " utility by Stefano Fraccaro");
				Console.Write(@"The software is licensed under GPL v3
				
server=mail.server.com or mail.server.com:25
port=25 ( default is 25 )
timeout=milliseconds ( default 10000 )

from=sender@server.com
fromName=Sender name
to=recipient@server.com
cc=cc-recipient@server.com
bcc=bcc-recipient@server.com
subject=Subject of email
text=body of email (plain text or html)
file=body of email (plain text or html)
attach=file

user=username
pass=password

csv=file ( placeholder is {N} , index is zero-based )
csvsep=delimiter ( default is comma )
csvline=starting line number ( zero based, default is 0 )

");
				return;
			}
			
			if (string.IsNullOrEmpty(csvFile)) {

				// invio del messaggio SINGOLO
				using(SmtpClient smtpClient = new SmtpClient()) {
				    using(MailMessage message = new MailMessage())
				    {
				    	//validazione dati
				    	if (string.IsNullOrEmpty(emailMittente)) {
				    		Console.WriteLine("Missing FROM argument");
				    		return;
				    	}
				    	if (string.IsNullOrEmpty(server)) {
				    		Console.WriteLine("Missing SERVER argument");
				    		return;
				    	}
	
				    	//mittente
				    	if (string.IsNullOrEmpty(mittente)) mittente = emailMittente.Substring(0, emailMittente.IndexOf('@'));
				        MailAddress fromAddress = new MailAddress(emailMittente, mittente); 
				
				        smtpClient.Host = server;
				        smtpClient.Port = port;
				        if (!string.IsNullOrEmpty(user)) {
						    var basicCredential = new NetworkCredential(user, pass); 
					        smtpClient.UseDefaultCredentials = false;
					        smtpClient.Credentials = basicCredential;
				        }
				
				        message.From = fromAddress;
				        message.Subject = oggetto;
				        // Set IsBodyHtml to true means you can send HTML email.
				        message.IsBodyHtml = true;
				        message.Body = testo;
				        for (int i = 0; i < A.Count; ++i) message.To.Add(A[i]);
				        for (int i = 0; i < Cc.Count; ++i) message.CC.Add(Cc[i]);
				        for (int i = 0; i < Ccn.Count; ++i) message.Bcc.Add(Ccn[i]);
				        
				        for (int i = 0; i < Allegati.Count; ++i) message.Attachments.Add(new Attachment(Allegati[i]));
	
				        
				        try
				        {
					        smtpClient.Timeout = timeout;
				            smtpClient.Send(message);
	
				            Console.WriteLine("OK");
				        }
				        catch(Exception ex)
				        {
				        	Console.WriteLine("ERROR");
				        	Console.WriteLine(ex.Message);
				        }
				    }
				}
			
			} else {
			
				// invio dei messaggi MULTIPLI
				string[] rows = File.ReadAllLines(csvFile);
				bool error = false;

				//validazione dati
				if (string.IsNullOrEmpty(server)) {
		    		Console.WriteLine("Missing SERVER argument");
		    		return;
		    	}
		    	if (string.IsNullOrEmpty(emailMittente)) {
		    		Console.WriteLine("Missing FROM argument");
		    		return;
		    	}
				
				for (int k = csvLine; k < rows.Length; ++k)  {
					string row = rows[k];
					if (row.StartsWith("#", StringComparison.InvariantCultureIgnoreCase) || string.IsNullOrWhiteSpace(row)) continue;
					
					string[] data = row.Split(csvSep);
					
					using(SmtpClient smtpClient = new SmtpClient()) {
					    using(MailMessage message = new MailMessage())
					    {
		
					    	//mittente
					    	string locEmailMittente = Sostituisci(emailMittente, ref data);
					    	string locMittente = Sostituisci(mittente, ref data);
					    	if (string.IsNullOrEmpty(locMittente)) locMittente = locEmailMittente.Substring(0, locEmailMittente.IndexOf('@'));
					        MailAddress fromAddress = new MailAddress(locEmailMittente, locMittente); 
					
					        smtpClient.Host = server;
					        smtpClient.Port = port;
					        if (!string.IsNullOrEmpty(user)) {
							    var basicCredential = new NetworkCredential(user, pass); 
						        smtpClient.UseDefaultCredentials = false;
						        smtpClient.Credentials = basicCredential;
					        }
					
					        message.From = fromAddress;
					        message.Subject = Sostituisci(oggetto, ref data);
					        // Set IsBodyHtml to true means you can send HTML email.
					        message.IsBodyHtml = true;
					        message.Body = Sostituisci(testo, ref data);
					        for (int i = 0; i < A.Count; ++i) message.To.Add(Sostituisci(A[i], ref data));
					        for (int i = 0; i < Cc.Count; ++i) message.CC.Add(Sostituisci(Cc[i], ref data));
					        for (int i = 0; i < Ccn.Count; ++i) message.Bcc.Add(Sostituisci(Ccn[i], ref data));
					        
					        for (int i = 0; i < Allegati.Count; ++i) message.Attachments.Add(new Attachment(Sostituisci(Allegati[i], ref data)));
		
					        
					        try
					        {
						        smtpClient.Timeout = timeout;
					            smtpClient.Send(message);
					        }
					        catch(Exception ex)
					        {
					        	Console.WriteLine("ERROR on line " + k + " : " + row);
					        	Console.WriteLine(ex.Message);
					        	error = true;
					        	break;
					        }
					    }
					}
				}
				if (!error) Console.WriteLine("OK");

			}
			
		}
		
		static string Sostituisci(string sTesto, ref string[] dati) {
			
			for (int i = 0; i < dati.Length; ++i) {
				sTesto = sTesto.Replace("{" + i + "}", dati[i]);
			}
			return sTesto;
			
		}
		static bool ImportaDato(string dato) {
			if (dato == "/h" || dato == "/?" || dato == "--help") {
				showHelp = true;
				return true;
			}
			
			if (dato.StartsWith("subject=", StringComparison.InvariantCultureIgnoreCase)) {
				oggetto = dato.Substring(8);
				return true;
			}
			if (dato.StartsWith("fromName=", StringComparison.InvariantCultureIgnoreCase)) {
				mittente = dato.Substring(9);
				return true;
			}
			if (dato.StartsWith("from=", StringComparison.InvariantCultureIgnoreCase)) {
				emailMittente = dato.Substring(5);
				return true;
			}
			if (dato.StartsWith("a=", StringComparison.InvariantCultureIgnoreCase)) {
				A.Add(dato.Substring(2));
				return true;
			}
			if (dato.StartsWith("to=", StringComparison.InvariantCultureIgnoreCase)) {
				A.Add(dato.Substring(3));
				return true;
			}
			if (dato.StartsWith("cc=", StringComparison.InvariantCultureIgnoreCase)) {
				Cc.Add(dato.Substring(3));
				return true;
			}
			if (dato.StartsWith("ccn=", StringComparison.InvariantCultureIgnoreCase)) {
				Ccn.Add(dato.Substring(4));
				return true;
			}
		
			//credenziali
			if (dato.StartsWith("user=", StringComparison.InvariantCultureIgnoreCase)) {
				user = dato.Substring(5);
				return true;
			}
			if (dato.StartsWith("pass=", StringComparison.InvariantCultureIgnoreCase)) {
				pass = dato.Substring(5);
				return true;
			}

			//server
			if (dato.StartsWith("server=", StringComparison.InvariantCultureIgnoreCase)) {
				server = dato.Substring(7);
				if (server.IndexOf(':') > 0) {
					int tPort = 0;
					if (int.TryParse(server.Substring(server.IndexOf(':')+1), out tPort) && tPort > 0 && tPort < 65535) {
						server = server.Substring(0, server.IndexOf(':'));
						port = tPort;
						return true;
					} else {
						Console.WriteLine("ERROR" + Environment.NewLine + "PORT is not valid");
						return false;
					}
				}
				return true;
			}
			if (dato.StartsWith("port=", StringComparison.InvariantCultureIgnoreCase)) {
				int tPort = 0;
				if (int.TryParse(dato.Substring(5), out tPort) && tPort > 0 && tPort < 65535) {
					port = tPort;
					return true;
				} else {
					Console.WriteLine("ERROR" + Environment.NewLine + "PORT is not valid");
					return false;
				}
			}
			if (dato.StartsWith("timeout=", StringComparison.InvariantCultureIgnoreCase)) {
				int tmp = 0;
				if (int.TryParse(dato.Substring(8), out tmp) && tmp > 0) {
					timeout = tmp;
					return true;
				} else {
					Console.WriteLine("ERROR" + Environment.NewLine + "TIMEOUT is not a positive number");
					return false;
				}
			}

			// allegati
			if (dato.StartsWith("attach=", StringComparison.InvariantCultureIgnoreCase)) {
				string fAttach = dato.Substring(7);
				if (File.Exists(fAttach)) Allegati.Add(fAttach);
				return true;
			}
			
			//corpo messaggio
			if (File.Exists(dato)) {
				testo = File.ReadAllText(dato);
				return true;
			}
			if (dato.StartsWith("text=", StringComparison.InvariantCultureIgnoreCase) || dato.StartsWith("body=", StringComparison.InvariantCultureIgnoreCase)) {
				testo = dato.Substring(5);
				return true;
			}
			
			//database
			if (dato.StartsWith("csv=", StringComparison.InvariantCultureIgnoreCase)) {
				string tmp = dato.Substring(4);
				if (File.Exists(tmp)) {
					csvFile = tmp;
					return true;
				} else {
					Console.WriteLine("ERROR" + Environment.NewLine + "CSV file not found");
					return false;
				}
			}
			
			if (dato.StartsWith("csvsep=", StringComparison.InvariantCultureIgnoreCase)) {
				string tmp = dato.Substring(7);
				csvSep = tmp[0];
				return true;
			}
			
			if (dato.StartsWith("csvline=", StringComparison.InvariantCultureIgnoreCase)) {
				int tmp = 0;
				if (int.TryParse(dato.Substring(8), out tmp) && tmp >= 0) {
					csvLine = tmp;
					return true;
				} else {
					Console.WriteLine("ERROR" + Environment.NewLine + "CSV line is not a positive number");
					return false;
				}
			}
			
			// non ho fatto niente, quindi tutto OK
			return true;
		}
		
	}
}